Summary:    Expose PL_dirty, the flag that marks global destruction
Name:       perl-Devel-GlobalDestruction
Version:    0.14
Release:    3%{?dist}
License:    GPL+ or Artistic
URL:        https://metacpan.org/release/Devel-GlobalDestruction
Source0:    https://cpan.metacpan.org/authors/id/H/HA/HAARG/Devel-GlobalDestruction-%{version}.tar.gz

BuildRequires: coreutils findutils make perl-interpreter
BuildRequires: perl-generators perl(base) perl(Carp) perl(DynaLoader) perl(Exporter)
BuildRequires: perl(ExtUtils::MakeMaker) perl(File::Basename) perl(File::Spec) perl(File::Spec::Functions) perl(File::Temp)
BuildRequires: perl(Text::ParseWords) perl(B) perl(strict) perl(Sub::Exporter::Progressive)
BuildRequires: perl(warnings) perl(Config) perl(FindBin) perl(IPC::Open2) perl(POSIX) perl(threads) perl(threads::shared)
Requires:      perl(:MODULE_COMPAT_%{?perl_version})
BuildArch:     noarch

%description
Perl's global destruction is a little tricky to deal with with respect to finalizers because it's
not ordered and objects can sometimes disappear.

Writing defensive destructors is hard and annoying, and usually if global destruction is happening
you only need the destructors that free up non process local resources to actually execute.

For these constructors you can avoid the mess by simply bailing out if global destruction is in
effect.

%prep
%autosetup -n Devel-GlobalDestruction-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
rm -rf %{buildroot}
%make_install
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README t/
%{perl_vendorlib}/Devel/
%{_mandir}/man3/Devel::GlobalDestruction.3*

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.14-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.14-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 16 2023 Shuo Wang <abushwang@tencent.com> - 0.14-1
- initial build
